<?php 
/**
 * Model for Students
 *
 * @author Mills ABeiku Godfred
 */
class Student
{
	
	public $conn;
	
	function __construct()
	{
		$this->conn = Database::connect();
	}

    public function update_student(array $key_col_vals, array $values) {
        $sql = "UPDATE student SET ";
        $fields = array_keys($values);
        $vals = array_values($values);
        $key_cols = array_keys($key_col_vals);
        $key_vals = array_values($key_col_vals);
        foreach ($fields as $i=>$f) {
            $fields[$i] .= " = ? ";
        }

        $sql .= implode(",", $fields);
        $sql .= " WHERE " ;
        
        foreach ($key_cols as $i=>$f) {
            $key_cols[$i] .= " = ? ";
        }
        
        $sql .= implode(" AND ", $key_cols);

        $statement = $this->conn->prepare($sql);
        foreach ($vals as $i=>$v) {
            $statement->bindValue($i+1, $v);
        }
        
        foreach ($key_vals as $i=>$v) {
           if($i==0){
               $statement->bindValue((count($fields)+$i+1), $v);
            }else{
               $statement->bindValue((count($fields)+$i), $v);
            }
        }
        
       return  $statement->execute();

	}


	public function add_student(array $data){
		$sql = "INSERT INTO student ";
		$fields = array_keys($data);
		$vals = array_values($data);

		$sql .= "(".implode(",", $fields).")";
		$arr = array();
		foreach ($fields as $f) {
			$arr[] = "?";
		}
		$sql .= " VALUES(".implode(",", $arr).")";

		$statement = $this->conn->prepare($sql);

		foreach ($vals as $i => $v) {
			$statement->bindValue($i + 1, $v);
		}

		return $statement->execute();

	}
  
	
	public function read_all_students(){
		$sql = "SELECT a.*,b.*,c.*  FROM student a JOIN 
		program b ON a.student_course=b.program_id JOIN 
		academic_year c ON a.student_academic_year=c.academic_year_id";
		$statement = $this->conn->prepare($sql);
		$statement->execute();
		if ($statement->rowCount() > 0) {
			return $statement->fetchAll(PDO::FETCH_ASSOC);
		}
		return false;
    }

	

    public function read_student($student_id){
		$sql = "SELECT * FROM student
         WHERE student_id=:student_id";
		$statement = $this->conn->prepare($sql);
		$statement->bindParam(":student_id",$student_id);
		$statement->execute();
		if ($statement->rowCount() > 0) {
			return $statement->fetchAll(PDO::FETCH_ASSOC);
		}
		return false;
    }

    public function remove_student($student_id){
		$sql = "DELETE FROM student WHERE student_id=:student_id";
		$statement = $this->conn->prepare($sql);
        $statement->bindParam(":student_id",$student_id);
		$statement->execute();
		if ($statement->rowCount() > 0) {
            $statement->fetchAll(PDO::FETCH_ASSOC);
		}
		return false;
    }

}